---
updatedAt: 2026-02-10T12:01:11.000Z
---

# Bulk Update Users

**This API requires the Account Administrator role.**

Bulk updates Users using the file provided. The following file formats are supported:

* `.xlsx`

The following fields must be unique otherwise a `HTTP 409 Conflict` will be returned:
* `jobName`

Will trigger an asynchronous job, the status of which should be monitored via `/jobs/{jobId}`.

# OpenAPI definition

```json
{
  "openapi": "3.0.2",
  "x-explorer-enabled": false,
  "x-samples-languages": [
    "curl",
    "node",
    "java",
    "javascript",
    "python",
    "go"
  ],
  "info": {
    "title": "Admin - User",
    "description": "The User APIs are use to create, update and retrieve information about User and Profiles.\n\nThe Bulk User APIs are use to perform operations on users and jobs in bulk.\nUser Services support add, update, delete users in bulk and delete multiple jobs.\n\nUser Services will support multiple ways to provision Users/Agents\n  1. Programmatic Interface (Rest APIs)\n  2. User Interface\n",
    "contact": {
      "name": "Avaya API Team",
      "url": "https://developers.avayacloud.com/onecloud-ccaas",
      "email": "apiteam@avaya.com"
    },
    "license": {
      "name": "Avaya Software Development Kit (SDK) Software License Terms",
      "url": "http://support.avaya.com/css/P8/documents/101038288"
    },
    "version": "1.0.2"
  },
  "security": [
    {},
    {
      "BearerAuth": [],
      "AppKey": []
    }
  ],
  "servers": [
    {
      "url": "{protocol}://{server}:{port}{basePath}",
      "description": "Open API",
      "variables": {
        "protocol": {
          "enum": [
            "https"
          ],
          "default": "https"
        },
        "server": {
          "default": "HOST-REGION.api.avayacloud.com"
        },
        "port": {
          "enum": [
            "443"
          ],
          "default": "443"
        },
        "basePath": {
          "default": "/api/admin/user/v1"
        }
      }
    }
  ],
  "tags": [
    {
      "name": "Bulk User",
      "description": "Bulk operations related to Users, Add, Update, Delete, Export.\n"
    }
  ],
  "paths": {
    "/accounts/{accountId}/users:bulkUpdate": {
      "post": {
        "tags": [
          "Bulk User"
        ],
        "summary": "Bulk Update Users",
        "description": "**This API requires the Account Administrator role.**\n\nBulk updates Users using the file provided. The following file formats are supported:\n\n* `.xlsx`\n\nThe following fields must be unique otherwise a `HTTP 409 Conflict` will be returned:\n* `jobName`\n\nWill trigger an asynchronous job, the status of which should be monitored via `/jobs/{jobId}`.\n",
        "operationId": "bulkUpdateUsers",
        "parameters": [
          {
            "$ref": "#/components/parameters/accountId"
          },
          {
            "$ref": "#/components/parameters/jobName"
          }
        ],
        "requestBody": {
          "content": {
            "multipart/form-data": {
              "schema": {
                "type": "object",
                "properties": {
                  "file": {
                    "type": "string",
                    "format": "binary"
                  }
                }
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UsersImportResponse"
                },
                "examples": {
                  "Bulk Update": {
                    "$ref": "#/components/examples/BulkAddedUsers"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/ErrorConstraintViolation"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/NotFound"
          },
          "409": {
            "$ref": "#/components/responses/JobNameExists"
          },
          "500": {
            "$ref": "#/components/responses/InternalServer"
          }
        }
      }
    }
  },
  "components": {
    "securitySchemes": {
      "BearerAuth": {
        "type": "http",
        "scheme": "bearer",
        "description": "This API uses Bearer Token Authorization Flow",
        "bearerFormat": "JWT"
      },
      "AppKey": {
        "type": "apiKey",
        "in": "header",
        "name": "appkey",
        "description": "This API needs an appKey as header"
      }
    },
    "responses": {
      "ErrorConstraintViolation": {
        "description": "Constraint Violation",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorConstraintViolation"
              }
            }
          }
        }
      },
      "Unauthorized": {
        "description": "Unauthorized",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorUnauthorized"
              }
            }
          }
        }
      },
      "InternalServer": {
        "description": "Request processing failed",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorInternalServerError"
              }
            }
          }
        }
      },
      "Forbidden": {
        "description": "Forbidden",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorForbidden"
              }
            }
          }
        }
      },
      "NotFound": {
        "description": "Not Found",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorNotFound"
              }
            }
          }
        }
      },
      "JobNameExists": {
        "description": "Conflict",
        "content": {
          "application/problem+json": {
            "schema": {
              "$ref": "#/components/schemas/Problem"
            },
            "examples": {
              "default": {
                "$ref": "#/components/examples/ErrorJobNameExists"
              }
            }
          }
        }
      }
    },
    "schemas": {
      "Problem": {
        "type": "object",
        "description": "<b>Problem Detail</b> as a way to carry machine-readable details of errors in a HTTP response to avoid the need to define new error response formats for HTTP APIs <a href=\"https://tools.ietf.org/html/rfc7807\">RFC 7807</a>\n",
        "properties": {
          "type": {
            "type": "string",
            "format": "uri",
            "description": "An absolute URI that identifies the problem type. When dereferenced, it SHOULD provide human-readable documentation for the problem type (e.g., using HTML).\n",
            "default": "about:blank",
            "example": "https://developers.avayacloud.com/onecloud-ccaas/docs/error-handling#constraint-violation"
          },
          "title": {
            "type": "string",
            "description": "A short, summary of the problem type. Written in english and readable for engineers (usually not suited for non technical stakeholders and not localized).\n",
            "example": "Service Unavailable",
            "nullable": true
          },
          "status": {
            "type": "integer",
            "format": "int32",
            "description": "The HTTP status code generated by the origin server for this occurrence of the problem.\n",
            "minimum": 100,
            "maximum": 600,
            "exclusiveMaximum": true,
            "example": 503,
            "nullable": true
          },
          "detail": {
            "type": "string",
            "description": "A human readable explanation specific to this occurrence of the problem.\n",
            "example": "Connection to database timed out",
            "nullable": true
          },
          "instance": {
            "type": "string",
            "format": "uri",
            "description": "An absolute URI that identifies the specific occurrence of the problem. It may or may not yield further information if dereferenced.\n",
            "nullable": true
          },
          "violations": {
            "type": "array",
            "description": "A list of violations that occurred as a result of invalid data provided as part of a request.\n",
            "nullable": true,
            "items": {
              "type": "object",
              "properties": {
                "field": {
                  "type": "string",
                  "description": "The name of the field in the request that caused the violation. This can be the name of a path parameter, query parameter, or a field within the request body.\n",
                  "example": "accountId"
                },
                "message": {
                  "type": "string",
                  "description": "A human readable explanation specific to this occurrence of the violation.\n",
                  "example": "must match \"^[a-zA-Z]{6}$\""
                },
                "code": {
                  "type": "integer",
                  "format": "int32",
                  "description": "The violation code generated by the server for this occurrence of the violation. Use this code when implementing any error handling logic instead of the message, as the message can change.\n",
                  "example": 20006
                }
              }
            },
            "example": [
              {
                "field": "emailAddress",
                "message": "must not be null",
                "code": 20002
              },
              {
                "field": "accountId",
                "message": "must match \"^[a-zA-Z]{6}$\"",
                "code": 20006
              }
            ]
          }
        }
      },
      "UsersImportResponse": {
        "description": "User import response to notify that user import accepted.",
        "type": "object",
        "properties": {
          "jobId": {
            "description": "An unique id mapped to each user import job.",
            "type": "string",
            "example": "c8c2909d-75e9-484a-94c0-b7e8d30771fe",
            "minLength": 36,
            "maxLength": 36,
            "pattern": "^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$"
          },
          "url": {
            "description": "Details of users import job",
            "type": "string",
            "example": "/api/admin/user/v1/accounts/ABCDEF/jobs/c8c2909d-75e9-484a-94c0-b7e8d30771fe",
            "maxLength": 2048
          }
        },
        "title": "UsersImportResponse"
      }
    },
    "parameters": {
      "accountId": {
        "name": "accountId",
        "description": "The unique 6 character internal id that represents the customer account.",
        "required": true,
        "in": "path",
        "schema": {
          "type": "string",
          "minLength": 6,
          "maxLength": 6,
          "pattern": "^[a-zA-Z]{6}$",
          "example": "ABCDEF"
        }
      },
      "jobName": {
        "name": "jobName",
        "in": "query",
        "description": "Optional, job name that can be provided to uniquely identify the job.",
        "required": false,
        "schema": {
          "type": "string",
          "minLength": 1,
          "maxLength": 255,
          "pattern": "^[\\p{L}\\p{M}\\p{N}\\p{IsKatakana}0-9]+[\\s\\p{L}\\p{M}\\p{N}\\p{IsKatakana}0-9\\-\\[\\]\\\\_\\.\\+\\*\\'\\\"\\!\\|\\(\\)\\{\\}\\;\\:\\,\\^\\+\\<\\>\\&\\£\\@\\$\\¥\\€\\`\\~\\?\\#\\%\\=]*$",
          "example": "Bulk Job"
        }
      }
    },
    "examples": {
      "ErrorConstraintViolation": {
        "description": "Constraint Violation",
        "value": {
          "type": "https://developers.avayacloud.com/avaya-experience-platform/docs/error-handling#constraint-violation",
          "title": "Constraint Violation",
          "status": 400,
          "detail": "A problem that indicates a syntactically correct, yet semantically illegal request. The Server can not process this request until the client resolves the semantic errors described in the violations section.",
          "violations": [
            {
              "field": "accountId",
              "message": "must match \"^[a-zA-Z]{6}$\"",
              "code": 20006
            }
          ]
        }
      },
      "ErrorUnauthorized": {
        "description": "Unauthorized",
        "value": {
          "type": "https://developers.avayacloud.com/avaya-experience-platform/docs/error-handling#unauthorized",
          "title": "Unauthorized",
          "status": 401,
          "detail": "This operation requires authentication. See https://developers.avayacloud.com/avaya-experience-platform/docs/how-to-authenticate-with-ccaas-apis"
        }
      },
      "ErrorForbidden": {
        "description": "Forbidden",
        "value": {
          "type": "https://developers.avayacloud.com/avaya-experience-platform/docs/error-handling#forbidden",
          "title": "Forbidden",
          "status": 403,
          "detail": "According to the access control policy the current user and/or accountId does not have permission to access this resource."
        }
      },
      "ErrorNotFound": {
        "description": "Not Found",
        "value": {
          "type": "https://developers.avayacloud.com/avaya-experience-platform/docs/error-handling#resource-not-found",
          "title": "Resource Not Found",
          "status": 404,
          "detail": "Either there is no API method associated with the URL path of the request, or the request refers to one or more resources that were not found."
        }
      },
      "ErrorInternalServerError": {
        "description": "Server Error",
        "value": {
          "type": "https://developers.avayacloud.com/avaya-experience-platform/docs/error-handling#server-error",
          "title": "Server Error",
          "status": 500,
          "detail": "An internal server error was encountered."
        }
      },
      "BulkAddedUsers": {
        "description": "Bulk Users Response",
        "value": {
          "jobId": "c8c2909d-75e9-484a-94c0-b7e8d30771fe",
          "url": "/api/admin/user/v1/accounts/ABCDEF/jobs/c8c2909d-75e9-484a-94c0-b7e8d30771fe"
        }
      },
      "ErrorJobNameExists": {
        "description": "Constraint Violation",
        "value": {
          "type": "https://developers.avayacloud.com/avaya-experience-platform/docs/error-handling#conflict",
          "title": "Conflict",
          "status": 409,
          "detail": "A resource with the same unique constraint values already exists.",
          "violations": [
            {
              "field": "jobName",
              "message": "A job with this name already exists"
            }
          ]
        }
      }
    }
  },
  "x-readme": {
    "proxy-enabled": true
  }
}
```